/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2016 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/*******************************************************************************
* File Name    : UART0.c
* Device(s)    : R5F100LE
* Tool-Chain   : CCRL
* Description  : Oobt@̃T|[g֐ł
* Creation Date: 2016/08/11
*******************************************************************************/

/*******************************************************************************
Includes
*******************************************************************************/
#include "r_cg_macrodriver.h"
#include "UART0.h"
#include "r_cg_userdefine.h"

/*******************************************************************************
Pragma directive
*******************************************************************************/

/*******************************************************************************
Global variables and functions
*******************************************************************************/
volatile uint8_t g_rx_buff[16];                 /* MpOobt@     */
volatile uint8_t g_rx_rdpt;                     /* f[^̓ǂݏo|C^ */
volatile uint8_t g_rx_dtno;                     /* i[Ăf[^   */
volatile uint8_t g_rx_status;                   /* MXe[^XtO     
        bit7 : I[ot[EtO                                         */                                                                                                                          
/*******************************************************************************
* Function Name: init_bf
* Description  : Oobt@̃|C^
* Arguments    : None
* Return Value : None
*******************************************************************************/
void init_bf(void)
{

    SRMK0 = 1;                                  /* INTSR0Ƃ̔r       */
    g_rx_rdpt = 0x00;                           /* ǂݏo|C^   */
    g_rx_dtno = 0x00;                           /* f[^NA         */
    g_rx_status = 0x00;                         /* Xe[^XNA       */
    SRMK0 = 0;                                  /* r䊮             */

}

/*******************************************************************************
* Function Name: chk_status
* Description  : Oobt@̏ԊmF
* Arguments    : None
* Return Value : Mf[^+Xe[^X
*               bit7 : I[ot[EtO
*               bit6,5 : 0,0
*               bit4-0 : f[^
*******************************************************************************/
uint8_t chk_status(void)
{
    uint8_t work;

    SRMK0 = 1;                                  /* INTSR0Ƃ̔r       */
    work = g_rx_status;                         /* Xe[^Xǂݏo       */
    g_rx_status = 0x00;                         /* Xe[^XNA       */
    work |= g_rx_dtno;                          /* f[^ǂݏo         */
    SRMK0 = 0;                                  /* r䊮             */
    return ( work );

}

/*******************************************************************************
* Function Name: get_data
* Description  : Oobt@1f[^ǂݏo
* Arguments    : None
* Return Value : f[^
*******************************************************************************/
uint8_t get_data(void)
{
    uint8_t work;

    if ( 0 == g_rx_dtno )
    {
        work = 0x00;                            /* f[^Ȃ΁C0x00   */
    }
    else
    {
        work = g_rx_buff[g_rx_rdpt];            /* f[^̓ǂݏo         */

        SRMK0 = 1;                              /* INTSR0Ƃ̔r       */
        g_rx_dtno--;
        g_rx_rdpt++;                            /* |C^XV             */
        g_rx_rdpt &= 0x0F;
        SRMK0 = 0;                              /* r䊮             */
    }

    return ( work );

}

/*******************************************************************************
* Function Name: get_blk
* Description  : Oobt@w肳ꂽf[^ǂݏoi]j
* Arguments    : i[|C^Cf[^
* Return Value : cf[^
*******************************************************************************/
uint8_t get_blk(uint8_t * const buff, uint8_t number)
{

    uint8_t work;
    uint8_t cnt;                                /* ]pJE^           */
    uint8_t * gp_buff;                          /* ]p|C^           */

    work = number;                              /* vf[^Zbg     */

    if ( ( 0 != number ) && ( 0 != g_rx_dtno ) )
    {                               /* ]f[^ꍇ                 */

        gp_buff = buff;                         /* ]|C^ݒ     */

/* ---------------------------------------------------------------------------

    ]f[^Zo

----------------------------------------------------------------------------*/

        if ( number < g_rx_dtno )
        {                           /* vf[^ʈȉ̏ꍇ           */
            cnt = number;                       /* ]f[^Zbg     */
            work = 0;                           /* cf[^0ɂ    */
        }
        else
        {                           /* vf[^ʈȏ̏ꍇ           */
            cnt = g_rx_dtno;                    /* ]̓obt@̑S */
            work = number - g_rx_dtno;          /* cf[^Zo       */
        }

/* ---------------------------------------------------------------------------

    f[^]

----------------------------------------------------------------------------*/

        for (  ; cnt > 0 ; cnt-- )
        {
            *gp_buff = g_rx_buff[g_rx_rdpt];    /* Oobt@]   */
            SRMK0 = 1;                          /* INTSR0Ƃ̔r       */
            g_rx_rdpt++;                        /* ǂݏo|C^XV   */
            g_rx_rdpt &= 0x0F;
            g_rx_dtno--;                        /* f[^|1            */
            SRMK0 = 0;                          /* INTSR0Ƃ̔rI   */
            gp_buff++;                          /* ]|C^XV       */

        }
    

    }

    return( work );

}
